'''
Remote client for simpleWindowPlot functions

Cmd:

python.exe .\workspace\bealjas\src\bealjas\examples\simpleClient.py tile0 localhost 31278

'''



if __name__ == '__main__':
    import socket
    socket.socket(socket.AF_INET, socket.SOCK_STREAM)
    
    import sys
    assert(len(sys.argv) == 4), 'Usage: %s clientID masterHostname masterPort' % (sys.argv[0])
    
    clientID = sys.argv[1]
    host = sys.argv[2]
    port = int(sys.argv[3])
    
    from simpleWindowPlot import SimpleState
    stateObject = SimpleState()
    
    from bealjas.utils.bealjas2pyplot import createWindow, guiLoop, closeWindow, setWindowPosSize, getWindowPosSize, setWindowVisible
    from bealjas.coordinator.tileCoordinator import startTileCoordinator
    startTileCoordinator(clientID, host, port,
                         createWindow, guiLoop, closeWindow, setWindowVisible, getWindowPosSize, setWindowPosSize,
                         stateObject)