'''
A simple demo of the windowPlotter
'''
from bealjas.coordinator.windowCoordinator import WindowCoordinator

class SimpleState:
    def __init__(self):
        self.vals = []
        self.vals.append( [1, 2, 3, 4, 5, 6] )
        self.vals.append( [1, 2, 1, 1, 1, 1] )
        self.vals.append( [6, 5, 4, 3, 2, 1] )
        self.vals.append( [3, 1, 2, 7, 8] )
        self.vals.append( [3, 5, 1] )
        self.vals.append( [2, 5, 2, 5, 2, 5, 2, 10] )
        self.vals.append( [2, 1, 1] )
        self.vals.append( [3, 5, 1, 1, 5, 3] )
        self.vals.append( [6, 5, 1, 6, 1, 6] )
        self.vals.append( [6, 6, 6] )
        
    def getVals(self, taskID):
        return self.vals[taskID]
        
def simplePlot(stateObject, logger, taskID):
    '''
    Plot a graph for the data in the state object
    
    @task index of data in the state object
    '''    
    import matplotlib.pyplot as plt
    #print 'Creating simple graph'    
    plt.plot(stateObject.getVals(taskID))
    plt.ylabel('Task %d' % (taskID))
    #print 'Calling draw'
    plt.draw()    
    
def simplePlot2(stateObject, logger, taskID):
    '''
    Plot a graph for the data in the state object
    
    @task index of data in the state object
    '''    
    import matplotlib.pyplot as plt    
    vals = stateObject.getVals(taskID)
    negVals = []
    for v in vals:
        negVals.append(v * -1)
    plt.plot(negVals)
    #print 'Calling draw again'
    plt.draw()        

def simplePlot3(stateObject, logger, taskID):
    '''
    Plot a graph for the data in the state object
    
    @task index of data in the state object
    '''    
    import matplotlib.pyplot as plt        
    revVals = stateObject.getVals(taskID)[:]
    revVals.reverse()
    plt.plot(revVals)
    #print 'Calling draw for the 3rd time'
    plt.draw()        


def noPlot(stateObject, logger, taskID):
    print 'Do nothing'
    pass
    
def simpleFilter(stateObject, logger, args=None):
    '''
    Simple filter that always return False (hide visualization or kill task)
    '''
    return False

def lenFilter(stateObject, logger, vi):
    '''
    args: index in state objects vals array
    '''
    if len(stateObject.vals[vi]) != 6:
        return False
    else:
        return True
    
def lenFilter2(stateObject, logger, vi):
    '''
    args: index in state objects vals array
    '''
    if len(stateObject.vals[vi]) <= 6:
        return False
    else:
        return True
    

def doSimplePlot(nTiles, nTasks, nSlaves, nWindows):
    from bealjas.utils.bealjas2pyplot import createWindow, guiLoop, closeWindow, setWindowPosSize, getWindowPosSize, setWindowVisible
    
    coordinator = None
    if nTiles == 0:
        print '[Main] Create WINDOW coordinator'    
        coordinator = WindowCoordinator(nWindows, nSlaves, createWindow, guiLoop, closeWindow, setWindowVisible, getWindowPosSize, setWindowPosSize, SimpleState())
    else:
        from bealjas.coordinator.masterCoordinator import startMasterCoordinator
        coordinator = startMasterCoordinator(nTiles, nWindows, nSlaves, "localhost", 31278) 
    raw_input('[Main] Enter to start slaves')
    coordinator.startSlaves(simplePlot, range(nTasks))
    
    raw_input("[Main] Enter for second plot: ")
    coordinator.visualize(simplePlot2, range(nTasks))
    
    raw_input("[Main] Enter to hide windows: ")
    coordinator.filterVisible(simpleFilter)
    
    raw_input("[Main] Enter to show windows: ")
    coordinator.filterVisibleOff()
    
    raw_input("[Main] Enter to show next: ")
    coordinator.showNext()
    #raw_input("[Main] Enter to show next: ")
    #coordinator.showNext()        
                
    raw_input("[Main] Enter to kill slaves: ")
    coordinator.killSlaves()
    if nTiles > 0:
        raw_input("[Main] Enter to kill tile coordinators: ")
        coordinator.killTileCoordinators()
    
    raw_input("[Main] Enter to quit: ")
    
def doMoreAdvancedPlot(nTasks, nSlaves, nWindows):
    from bealjas.utils.bealjas2pyplot import createWindow, guiLoop, closeWindow, setWindowPosSize, getWindowPosSize, setWindowVisible
            
    # Create a WindowCoordinator with 4 windows and 4 slaves
    print '[Main] Create coordinator'    
    coordinator = WindowCoordinator(nWindows, nSlaves, createWindow, guiLoop, closeWindow, setWindowVisible, getWindowPosSize, setWindowPosSize, SimpleState())
    print '[Main] Start slaves'
    coordinator.startSlaves(simplePlot, range(nTasks))

    raw_input('[Main] Enter to reset views')
    coordinator.resetVisible()    
    
    coordinator.visualize(simplePlot2, range(nTasks))
    
    if 1:
        raw_input("[Main] Enter to show next (2 of 5): ")
        coordinator.showNext()
        raw_input("[Main] Enter to show next (3 of 5): ")
        coordinator.showNext()
        raw_input("[Main] Enter to show next (4 of 5): ")
        coordinator.showNext()
        raw_input("[Main] Enter to show next (5 of 5): ")
        coordinator.showNext()
        raw_input("[Main] Enter to show next (back to 1): ")
        coordinator.showNext()
        raw_input("[Main] Enter to show prev (5 of 5): ")
        coordinator.showPrevious()
        
    raw_input("[Main] Enter to filter windows: ")
    coordinator.pendingFilterVisible(lenFilter, range(nTasks)) 
    
    if 1:
        raw_input("[Main] Enter to show random: ")
        coordinator.showRandom()
        raw_input("[Main] Enter to show random: ")
        coordinator.showRandom()
        raw_input("[Main] Enter to show random: ")
        coordinator.showRandom()
        raw_input("[Main] Enter to show first: ")
        coordinator.showFirst()
    raw_input("[Main] Enter to show last: ")
    coordinator.showIndex(nTasks - 1)
    coordinator.filterVisibleOff()
    raw_input("[Main] Enter to show next (back to 1): ")
    coordinator.showNext()
    
    raw_input("[Main] Enter to filter kill windows: ")
    coordinator.filterKill(lenFilter2, range(nTasks))
    raw_input('[Main] Enter to reset views')
    coordinator.resetVisible()
    raw_input("[Main] Enter to show next and add new line: ")
    coordinator.showNext()
    coordinator.visualize(simplePlot3, range(nTasks))
            
    raw_input("[Main] Enter to kill slaves: ")
    coordinator.killSlaves()
    
    raw_input("[Main] Enter to quit: ")
    
def doLoopPlot(nTasks, nSlaves, nWindows):
    from bealjas.utils.bealjas2pyplot import createWindow, guiLoop, closeWindow, setWindowPosSize, getWindowPosSize, setWindowVisible
            
    # Create a WindowCoordinator with 4 windows and 4 slaves
    print '[Main] Create coordinator'    
    coordinator = WindowCoordinator(nWindows, nSlaves, createWindow, guiLoop, closeWindow, setWindowVisible, getWindowPosSize, setWindowPosSize)
    print '[Main] Start slaves'
    coordinator.startSlaves(simplePlot, range(nTasks), SimpleState())

    coordinator.consoleDriver()
    
    print("[Main] Add second line")    
    coordinator.visualize(simplePlot2, range(nTasks))
    
    coordinator.consoleDriver()
        
    print("[Main] Enter filter windows")
    coordinator.pendingFilterVisible(lenFilter, range(nTasks)) 
    
    coordinator.consoleDriver()
    
    print("[Main] Turn off visible filter")
    coordinator.filterVisibleOff()
    
    coordinator.consoleDriver()
    
    print("[Main] Filter kill windows")
    coordinator.filterKill(lenFilter2, range(nTasks))
    
    coordinator.consoleDriver()
    
    print("[Main] Add third line")
    coordinator.visualize(simplePlot3, range(nTasks))
    
    coordinator.consoleDriver()
    
    print("[Main] Close windows and kill slaves") 
    coordinator.killSlaves()
    
def stepByStep():
    import logging
    from bealjas.utils.bealjas2pyplot import createWindow, setWindowVisible, guiLoop
    from bealjas.utils.setupLogging import setupConsoleLogger
    
    logger, logfile = setupConsoleLogger('sbs', logging.INFO)
    createWindow()
    raw_input("[Main] Enter to hide: ")
    setWindowVisible(None, logger, False)

    raw_input("[Main] Enter to enter GUI loop: ")
    guiLoop()
    
    raw_input("[Main] Enter to plot: ")
    simplePlot(SimpleState(), logger, 0)
    
    raw_input("[Main] Enter to quit: ")

#
#
# Ipython import and run
# from bealjas.examples.simpleWindowPlot import doSimplePlot
# doSimplePlot(0, 1, 1, 1)
#
# Ipython module reload:
# import foo.bar.baz
# %load_ext autoreload
# %autoreload 2
# dreload(foo.bar.baz) 
#
    
if __name__ == '__main__':
    # tasks, slaves, windows
    doSimplePlot(0, 1, 1, 1)
    #doMoreAdvancedPlot()
    #stepByStep()