'''
Functions to serialize a function
'''
import marshal, types

def serialize(function):
    '''
    Serialize a function such that it can be sent to another process.
    
    @param function: function to serialize
    @return a serialized function that can be sent over a socket
    '''
    return marshal.dumps(function.func_code)    

def deserialize(data, functionName):
    '''
    Deserialize a serialized function and place it in the global namespace
    
    @param data: serialized function as returned from serialize()
    @param functionName: name given to the function
    @return: a reference to the function
    '''
    code = marshal.loads(data)
    return types.FunctionType(code, globals(), functionName);
    
    
