'''
Created on Jun 21, 2012

@author: larsab
'''
import unittest
import threading
import logging
import matplotlib.pyplot as plt
from bealjas.plotter.windowPlotter import WindowStatus
from bealjas.utils.bealjas2pyplot import createWindow, guiLoop, closeWindow, setWindowPosSize, getWindowPosSize, setWindowVisible
from bealjas.utils.setupLogging import setupConsoleLogger

class TestThread(threading.Thread):
    def __init__(self, windowStatus):
        threading.Thread.__init__(self)
        self.windowStatus = windowStatus
        
    def run(self):
        raw_input("Plot graph")        
        plt.plot([3, 1, 2, 7 , 8])
        
        raw_input("Signal GUI thread")
        self.windowStatus.redraw.acquire()
        self.windowStatus.nRedraws = 1
        self.windowStatus.redraw.notify()
        self.windowStatus.redraw.release()
        
        raw_input("Hide window")
        setWindowVisible(None, logger, False)
        
        raw_input("Show window")
        setWindowVisible(None, logger, True)
        
        raw_input("Show shown window")
        setWindowVisible(None, logger, True)
        
        raw_input("Hide and then hide hidden window")
        setWindowVisible(None, logger, False)
        setWindowVisible(None, logger, False)
        
        raw_input("Show window")
        setWindowVisible(None, logger, True)
        
        raw_input("Move window and resize window")
        setWindowPosSize(None, logger, (False, 0, 100, 250, 200))
        m, x, y, w, h = getWindowPosSize(None, logger)
        assert(m == False)
        assert(0 == x)
        assert(100 == y)
        assert(250 == w)
        assert(200 == h)
        
        raw_input("Maximize window size")
        setWindowPosSize(None, logger, (True, 0, 0, 0, 0))
        m, x, y, w, h = getWindowPosSize(None, logger)
        assert(m == True)
        
        raw_input("Move window and resize window")
        setWindowPosSize(None, logger, (False, 0, 100, 250, 200))
        m, x, y, w, h = getWindowPosSize(None, logger)
        assert(m == False)
        assert(0 == x)
        assert(100 == y)
        assert(250 == w)
        assert(200 == h)
        
        raw_input("Close window")
        closeWindow(None, logger)        
        
class Bealjas2PyplotTest(unittest.TestCase):
    
    def testAll(self):
        print 'WARNING: these test requires a user to verify the correctnes of the functions'
        testAll()

def testAll(logger):    
    windowStatus = WindowStatus()    
        
    raw_input("Start wp thread")
    t = TestThread(windowStatus)
    t.start()
    
    print "Create window"
    createWindow()

    print "Enter GUI loop"    
    guiLoop(windowStatus)
    
    print 'EXIT'

if __name__ == "__main__":
    #import sys;sys.argv = ['', 'Test.testName']
    #unittest.main()
    
    logger, ignored = setupConsoleLogger("untitest", logging.INFO)
    testAll(logger)