'''
Created on Jun 21, 2012

@author: larsab
'''
import unittest
import tempfile
import logging
import shutil
from bealjas.utils.setupLogging import setupConsoleLogger, setupFileLogger

class SetupLoggingTest(unittest.TestCase):
    
    def setUp(self):
        self.tmpLogDir = tempfile.mkdtemp()
        
    def tearDown(self):
        #shutil.rmtree(self.tmpLogDir)
        pass

    # NOTE! The output of this test must be checked manually
    def testConsoleLogger(self):
        print 'DEBUG'
        logger, ignored = setupConsoleLogger('unit-test.d', logging.DEBUG)
        self.printMessages(logger)
        
        print 'INFO'
        logger, ignored = setupConsoleLogger('unit-test.i', logging.INFO)
        self.printMessages(logger)
        
        print 'WARN'
        logger, ignored = setupConsoleLogger('unit-test.w', logging.WARN)
        self.printMessages(logger)
        
        print 'ERROR'
        logger, ignored = setupConsoleLogger('unit-test.e', logging.ERROR)
        self.printMessages(logger)
        
        print 'CRITICAL'
        logger, ignored = setupConsoleLogger('unit-test.c', logging.CRITICAL)
        self.printMessages(logger)
        
    def testFileLogger(self):
        logger, filename = setupFileLogger('unit-test.d', logging.DEBUG, {'dir':self.tmpLogDir})
        self.printMessages(logger)
        lines = open(filename).readlines()
        print lines
        self.assertEquals(5, len(lines))
        self.assertEquals('debug\n', lines[0])
        
        logger, filename = setupFileLogger('unit-test.i', logging.INFO, {'dir': self.tmpLogDir})
        self.printMessages(logger)
        lines = open(filename).readlines()
        self.assertEquals(4, len(lines))
        self.assertEquals('info\n', lines[0])
        
        logger, filename = setupFileLogger('unit-test.w', logging.WARN, {'dir': self.tmpLogDir})
        self.printMessages(logger)
        lines = open(filename).readlines()
        self.assertEquals(3, len(lines))
        self.assertEquals('warn\n', lines[0])
        
        logger, filename = setupFileLogger('unit-test.e', logging.ERROR, {'dir': self.tmpLogDir})
        self.printMessages(logger)
        lines = open(filename).readlines()
        self.assertEquals(2, len(lines))
        self.assertEquals('error\n', lines[0])
        
        logger, filename = setupFileLogger('unit-test.c', logging.CRITICAL, {'dir': self.tmpLogDir})
        self.printMessages(logger)
        lines = open(filename).readlines()
        self.assertEquals(1, len(lines))
        self.assertEquals('critical\n', lines[0])
        
        for lh in logger.handlers:
            if isinstance(lh, logging.FileHandler):
                lh.close()
            logger.removeHandler(lh)
        
    def printMessages(self, logger):
        logger.debug('debug')
        logger.info('info')
        logger.warn('warn')
        logger.error('error')
        logger.critical('critical')


if __name__ == "__main__":
    #import sys;sys.argv = ['', 'Test.testConsoleLoger']
    unittest.main()